//*************************************************
// CORSO PROGRAMMAZIONE PICMICRO
// Approfondimenti pratici
// http://www.settorezero.com
//
// (C) Bernardo Giovanni
//
// modulo: main.c
// autore: Bernardo Giovanni
// data:  12/10/11
// descrizione: esempio di utilizzo UART
// picmicro: PIC12F1822
// clock: 32MHz, interno
//
// E' VIETATA LA RIPUBBLICAZIONE SU ALTRI SITI,
// FORUM O ALTRI MEZZI
//*************************************************

#define  _XTAL_FREQ 32000000
#include <pic.h>
#include "usart12f.c"

// Config word
// ho selezionato oscillatore interno (FOSC_INTOSC). Di conseguenza RA5 usabile come I/O
// disabilitato il clock in uscita (CLKOUTEN_OFF). Di conseguenza RA4 usabile come I/O
// ho attivato il PLL (PLLEN_ON).
__CONFIG (FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_OFF & CP_OFF & CPD_OFF & BOREN_OFF & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
__CONFIG (WRT_OFF & PLLEN_ON & STVREN_OFF & BORV_19 & LVP_OFF);


void main(void)
	{
	/*
	Settaggio oscillatore
	bits 6-3 : 8MHz => 32MHz dato che PLLON
	bits 1-0 : il clock  determinato da config word, non si puo cambiare a runtime
	*/
	OSCCON=0b11110000; 

	ANSELA=0; // tutti io come digitali
	ADON=0; // modulo AD spento
	WPUA=0; // pullup disabilitate

	// Attendo che il clock sia pronto (HFIOFR)
	while (!HFIOFR) {continue;}
	
	// Inizializzo l'UART
	uart_init();
	
	while(1)
		{
		printf("SETTOREZERO.COM\n\r");
		} // while
	} // main
